/*
 * Pebble_Printing.cp
 *
 * This module contains code to print the contents of a window.
 */

#include "Pebble_Alerts.h"
#include "Pebble_Printing.h"
#include "Pebble_Windows.h"

/* Global Data */
THPrint hPrtRec = nil;

/* DoPageSetup
 * This routine calls the standard "PageSetup" dialog.  In the future, we'll use 
 * this to bitch if the user doesn't choose Landscape mode.
 */
void DoPageSetup(void)
{	
	
	PrOpen();
	if (!hPrtRec) {
		hPrtRec = (THPrint) NewHandle(sizeof(TPrint));
		if (!hPrtRec) {
			DoError("\pPrinting Error: Not Enough Memory!", 0, kNotFatal);
			return;
		}
		PrintDefault(hPrtRec);
	}
	if(PrError() != noErr) {
		SysBeep(3);
	}
	(void)PrStlDialog(hPrtRec);
	PrClose();
}

/* DoPrint
 * This prints the front most window
 */
void DoPrint(void)
{
	GrafPtr		savePort;
	TPrStatus	prStatus;
	TPPrPort	printPort;
	
	GetPort(&savePort);
	
	PrOpen();
	if (!hPrtRec) {
		hPrtRec = (THPrint) NewHandle(sizeof(TPrint));
		if (!hPrtRec) {
			DoError("\pPrinting Error: Not Enough Memory!", 0, kNotFatal);
			return;
		}
		PrintDefault(hPrtRec);
	}
	if (PrJobDialog(hPrtRec)) {
		printPort = PrOpenDoc(hPrtRec, nil, nil);
		SetPort(&printPort->gPort);
		PrOpenPage(printPort, nil);
		
		((TWindow *)FrontWindow())->Draw(kToPrinter);
		
		PrClosePage(printPort);
		PrCloseDoc(printPort);
		
		if (((* hPrtRec)->prJob.bJDocLoop == bSpoolLoop) && (PrError() == noErr)) {
			PrPicFile(hPrtRec, nil, nil, nil, &prStatus);
		}
	}
	SetPort(savePort);
	PrClose();
}