/* Pebble CDEF Tester.c
 *
 * Clicking in the active control tests the control.
 * Tapping or holding a key activates/deactivates the control
 * Clicking in the go-away box quits the program.
 *
 * I tried to make the program multifinder friendly, but sometimes it doesn't seem to 
 * behave that way; I'm not sure why not.
 *
 * 11 MAR 95 MDT
 */


void ToolBoxInit (void);
void DoEvent(EventRecord *e);
void MenuBarInit (void);

ControlHandle	c1, c2;
Boolean d = false;
WindowPtr w;
Boolean x = true;

main()
{
	EventRecord	e;
	Rect r;
	
	ToolBoxInit();
	MenuBarInit();
	
	w = GetNewCWindow(128, nil, (WindowPtr)-1);
	if (!w) return;
	ShowWindow(w);
	SetPort(w);
	
	SetRect(&r, 10,10,10,10);
	//SetRect(&r, 10,10,50,30);
	
	c1 = NewControl(w, &r, "\pTest", true, 0, 128, 129,(128<<4), 0);   /* IM I pg 319 */
	//c1 = NewControl(w, &r, "\pTest", true, 0, 0, 0,pushButProc, 0);   /* IM I pg 319 */
	if (!c1) return;
	
	OffsetRect(&r, 30, 0);
	c2 = NewControl(w, &r, "\pTest", true, 0, 130, 131,(128<<4)+1, 0);   /* IM I pg 319 */
	if (!c2) return;
	
	while(!d) {
		if(WaitNextEvent(everyEvent, &e, 3600L, nil)) {   /* IM VI chap. 5 pg 29 */
			DoEvent(&e);
		}
	}
}

void DoEvent(EventRecord *e)
{
	WindowPtr which;
	short thePart, value;
	ControlHandle	theC;
	
	
	switch (e->what) {
	case mouseDown:
		switch(FindWindow(e->where, &which)) {
		case inSysWindow:
			SystemClick(e, which);
			break;
		case inContent:
			GlobalToLocal(&e->where);
			if (FindControl(e->where, which, &theC)) 
				if (TrackControl(theC, e->where, nil))  { /* IM I pg 323 */
					//SysBeep(3);
					value = !GetCtlValue(theC);
					SetCtlValue(theC, !(GetCtlValue(theC)));
				}
			break;
		case inGoAway:
			if(TrackGoAway(w, e->where)) {   /* IM I pg 288 */
					d = true;
			}
			break;
		case inDrag:
			DragWindow(which, e->where, &qd.screenBits.bounds);   /* IM I pg 289 */
			break;
		}//switch
		break;
	case keyDown:
	case autoKey:
		SetPort(w);
		if (x) {
			HiliteControl(c1, 255);
			HiliteControl(c2, 255);
			x = false;
		} else {
			HiliteControl(c1, 0);
			HiliteControl(c2, 0);
			x = true;
		}

		DrawControls(w);
		break;	
	case updateEvt:
		SetPort(w);
		BeginUpdate((WindowPtr)e->message);   /* IM I pg 292 */
		DrawControls((WindowPtr)e->message);
		EndUpdate((WindowPtr)e->message);
		break;
	case activateEvt:
		SetPort(w);
		if (e->modifiers & 1) {
			HiliteControl(c1, 0);
			HiliteControl(c2, 0);
			x = true;
		} else {
			HiliteControl(c1, 255);
			HiliteControl(c2, 255);
			x = false;
		}
		DrawControls(w);
		break;
	case osEvt:
		SetPort(w);
		if ((e->message & suspendResumeMessage) == resumeFlag) {
			HiliteControl(c1, 0);
			HiliteControl(c2, 0);
			x = true;
		} else {
			HiliteControl(c1, 255);
			HiliteControl(c2, 255);
			x = false;
		}
		DrawControls(w);
	break;
	default:
		;
	}
}


/********** ToolBoxInit **********/

void ToolBoxInit(void)
{
	InitGraf (&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);
	InitCursor();
}

void MenuBarInit (void)
{
	Handle			menuBar;
	MenuHandle		menu;
	
	menuBar = GetNewMBar(128);			/* read menus into menu bar */
	if ( menuBar == nil )
	return;	
	SetMenuBar(menuBar);					/* install menus */
	DisposHandle(menuBar);
	AddResMenu(GetMHandle(128), 'DRVR');	/* add DA names to Apple menu */
	DrawMenuBar();
}

