/* Pebble CDEF Tester.c
 *
 * Clicking in the active control tests the control.
 * Tapping or holding a key activates/deactivates the control
 * Clicking in the go-away box quits the program.
 *
 * I tried to make the program multifinder friendly, but sometimes it doesn't seem to 
 * behave that way; I'm not sure why not.
 *
 * 11 MAR 95 MDT
 */
#include "MMR.h"

struct ControlRefConRec {
	GWorldPtr	tools;	
	short		numTools;
	Boolean		*enabled;
	Point		windowPt;
};
typedef struct ControlRefConRec ControlRefConRec;


void ToolBoxInit (void);
void DoEvent(EventRecord *e);
void MenuBarInit (void);

ControlHandle	c1, c2;
Boolean d = false;
WindowPtr w;
Boolean x = true;

main()
{
	EventRecord	e;
	Rect r;
	//GWorldPtr tools;
	ControlRefConRec *data;
	PicHandle	toolPict;
	short i;
	OSErr err;
	
	ToolBoxInit();
	MenuBarInit();
	
	w = GetNewCWindow(128, nil, (WindowPtr)-1);
	if (!w) return;
	ShowWindow(w);
	SetPort(w);
	
	data = (ControlRefConRec*) NewPtr(sizeof(ControlRefConRec));
	if (!data) ExitToShell();
	
// set data.tools
	toolPict = GetPicture(128);
	if (!toolPict) {
		ExitToShell();	
	}
	r = (*toolPict)->picFrame;
	OffsetRect(&r,-r.left, -r.top); // zero left and top edges of rect.
	err = MakeGWorld(&(data->tools), &r, 8);
	if (err) ExitToShell();
	DrawMyPict(data->tools,toolPict); 
	/*SetPort(w);
	DrawPicture(toolPict, &r);*/
	ReleaseResource((Handle)toolPict); // clean up after ourselves.

// set data.enabled.
	data->enabled = (Boolean *)NewPtr(sizeof(Boolean) * 14);
	if (!data->enabled) ExitToShell();
	for (i=0; i<14; i++) {
		data->enabled[i] = true;
	}
// set data.numTools
	data->numTools = 14;
	
	//SetRect(&r, 10,10,10,10);
	SetRect(&r, 13,30,10,10);
	
	c1 = NewControl(w, &r, "\pTest", true, 0, 0, 14,(128<<4)+1, (long) data);   
	if (!c1) return;

	while(!d) {
		FrameRect(&(*c1)->contrlRect);
		if(WaitNextEvent(everyEvent, &e, 3600L, nil)) { 
			DoEvent(&e);
		}
	}
}

void DoEvent(EventRecord *e)
{
	WindowPtr which;
	short thePart, value;
	ControlHandle	theC;
	
	
	switch (e->what) {
	case mouseDown:
		switch(FindWindow(e->where, &which)) {
		case inSysWindow:
			SystemClick(e, which);
			break;
		case inContent:
			GlobalToLocal(&e->where);
			if (FindControl(e->where, which, &theC)) 
				if (TrackControl(theC, e->where, (ControlActionUPP) -1L))  { /* IM I pg 323 */
					//SysBeep(3);
					//value = !GetCtlValue(theC);
					//SetCtlValue(theC, !(GetCtlValue(theC)));
				}
			break;
		case inGoAway:
			if(TrackGoAway(w, e->where)) {   /* IM I pg 288 */
					d = true;
			}
			break;
		case inDrag:
			DragWindow(which, e->where, &qd.screenBits.bounds);   /* IM I pg 289 */
			break;
		}//switch
		break;
	case keyDown:
	case autoKey:
		SetPort(w);
		if (x) {
			HiliteControl(c1, 255);
			//HiliteControl(c2, 255);
			x = false;
		} else {
			HiliteControl(c1, 0);
			//HiliteControl(c2, 0);
			x = true;
		}

		DrawControls(w);
		break;	
	case updateEvt:
		SetPort(w);
		BeginUpdate((WindowPtr)e->message);   /* IM I pg 292 */
		DrawControls((WindowPtr)e->message);
		EndUpdate((WindowPtr)e->message);
		break;
	case activateEvt:
		SetPort(w);
		if (e->modifiers & 1) {
			HiliteControl(c1, 0);
			//HiliteControl(c2, 0);
			x = true;
		} else {
			HiliteControl(c1, 255);
			//HiliteControl(c2, 255);
			x = false;
		}
		DrawControls(w);
		break;
	case osEvt:
		SetPort(w);
		if ((e->message & suspendResumeMessage) == resumeFlag) {
			HiliteControl(c1, 0);
			//HiliteControl(c2, 0);
			x = true;
		} else {
			HiliteControl(c1, 255);
			//HiliteControl(c2, 255);
			x = false;
		}
		DrawControls(w);
	break;
	default:
		;
	}
}


/********** ToolBoxInit **********/

void ToolBoxInit(void)
{
	InitGraf (&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);
	InitCursor();
}

void MenuBarInit (void)
{
	Handle			menuBar;
	MenuHandle		menu;
	
	menuBar = GetNewMBar(128);			/* read menus into menu bar */
	if ( menuBar == nil )
	return;	
	SetMenuBar(menuBar);					/* install menus */
	DisposHandle(menuBar);
	AddResMenu(GetMHandle(128), 'DRVR');	/* add DA names to Apple menu */
	DrawMenuBar();
}

