/*
 * Cursors.h
 *
 * Version 2.0 - 1/1/95
 * A complete re-write in an attempt to make it better.
 */

#ifndef __CURSORSH__
#define __CURSORSH__

#define kNumCrsr			17
#define kBaseCrsrID			128
#define kNumCrsrWatches		8

#define kCrsrArrow			0
#define kCrsrWatch			1
#define kCrsrEraser			9
#define kCrsrPencil			10
#define kCrsrEyeDropper		11
#define kCrsrPaintBucket	12
#define kCrsrRectSelect		13
#define kCrsrEyeBeam		14
#define kCrsrEyeGlass		15
#define kCrsrNoGood			16

#define kCrsrWatchOn		1
#define kCrsrWatchOff		0
#define kCrsrWatchSpin		-1

enum CursorTrackingStatus {
	off = 0,
	arrow,
	watch,
	primary,
	secondary
};
typedef enum CursorTrackingStatus CursorTrackingStatus;

struct MouseCursors {
	short		crsrID[kNumCrsr];
	CCrsrHandle crsr[kNumCrsr];
};
typedef struct MouseCursors MouseCursors;

struct CursorTracking {
	RgnHandle ctRgn;
	CursorTrackingStatus status;
	short primaryID;
	short secondaryID;
	short watchPhase;
};
typedef struct CursorTracking CursorTracking;
	  
	  
extern MouseCursors   gEMCursors;
extern CursorTracking gCursTracking;

void InitMouseCursors(void);
void StartCursTracking(WindowPtr w, RgnHandle rgn, short primary, short secondary);
void EndCursTracking(WindowPtr w);
void SuspendCursTracking(void);
void ResumeCursTracking(WindowPtr w);
void DoMouseMoved(WindowPtr w, Boolean optionKeyIsDown);
void CursorEventProcessing(WindowPtr w, Boolean optionKeyIsDown);
void DoWatchCursor(WindowPtr w, short action);
void SetMouseCursor(short crsrType);
void SetProperMouseCursor(WindowPtr w);


#endif // __CURSORSH__