/*
 * Maps.c
 */
 
#include "MMR.h"
#include "Maps.h"
#include "Tiles.h"

#include "Scenario.h"


// Tiles are 32x32. I pulled the 32s out of the code and replaced them with the following
// constants. Note, I left the variables xMod32 etc alone - still, that's where they 
// get their names.
#define kTileWidth	32
#define kTileHeight 32

/* DrawMap
 * world is the world to draw in. 
 * x & y are the position of the scroll bars: 0 <= x < 2048 (or so)
 */
void DrawMap(GWorldPtr world, Rect *rect, short mapID, short x, short y)
{
	GWorldPtr oldGW;
	GDHandle oldGD;
	Rect r,s;
	long 	xMod32,	yMod32,	startTileX,	startTileY,	finTileX, finTileY;
	long j,i;
	long mpSize = gScenario.outsideMapsSize[mapID].h; // mdt 3/11/96
	unsigned char *map;
	
	if (!rect) return;
	if (!world) return;
	r = *rect; 
	
	HLock(gScenario.outsideMaps[mapID].map);
	map = (unsigned char *)*gScenario.outsideMaps[mapID].map;

	xMod32 = x % kTileWidth;
	yMod32 = y % kTileHeight;
	startTileX = x / kTileWidth;
	startTileY = y / kTileHeight;
	finTileX = (r.right - r.left - xMod32) / kTileWidth;
	finTileY = (r.bottom - r.top - yMod32) / kTileHeight;
	
	GetGWorld(&oldGW, &oldGD);
	LockPixels(world->portPixMap);
	SetGWorld(world, 0L);
	( *( ( *gScenario.tiles->portPixMap )->pmTable ) )->ctSeed = ( *( ( *( ( *( GetGDevice() ) )->gdPMap ) )->pmTable ) )->ctSeed; // smash 'em 4/24/96
	SetStdForeNBackColor();
	
	for (j=0;j<finTileY+3; j++) { // the threes here are fudge factors .. I think
		for (i=0; i<finTileX+3; i++) {
			SetRect(&s,	(r.left-xMod32)+(kTileWidth*i),
						(r.top-yMod32)+(kTileHeight*j),
						(r.left-xMod32 + kTileWidth)+(kTileWidth*i),
						(r.top-yMod32 + kTileHeight)+(kTileHeight*j));
			PlotTile(gScenario.tiles,map[(mpSize * (startTileY + j)) + startTileX + i],world,&s);
		}
	}
	SetGWorld(oldGW,oldGD);
	UnlockPixels(world->portPixMap);

	HUnlock(gScenario.outsideMaps[mapID].map);
}