/*
 * Monsters.c
 */

#include "Monsters.h"
#include "Scenario.h"

#define kMonsTileTypeOffset	0
#define kMonsTileOnOffset	0x20
#define kMonsXPosOffset		0x40
#define kMonsYPosOffset		0x60
#define kMonsInclinOffset	0x80

void FindMonsterByPosition(short monsID, Point position, MonsterRec *monster)
{
	short x,y,i;
	Handle monsters = gScenario.monsters[monsID].mons;
	
	if (!monster) return;
	
	x = position.h;
	y = position.v;
	
	for (i=0;i < kMaxMonsters; i++) {
		if ( ((*monsters)[kMonsXPosOffset + i] == x) && 
		     ((*monsters)[kMonsYPosOffset + i] == y) )	break;
	}
	FindMonsterByNumber(monsID, i, monster);
}

void FindMonsterByNumber(short monsID, short number, MonsterRec *monster)
{
	Handle monsters = gScenario.monsters[monsID].mons;
	unsigned char tmp=0;
	
	if (!monster) return;

	if ((number < 0 ) || (number >= kMaxMonsters)) {
		monster->monsNumber = -1;
		monster->monsTileType = -1;
		monster->monsTileOnTopOf = -1;
		monster->monsPosition.h = -1;
		monster->monsPosition.v = -1;
		monster->monsTLKSID = -1;
		monster->monsInclination = -1;
	} else {
		monster->monsNumber = number;
		monster->monsTileType = (unsigned char)((*monsters)[kMonsTileTypeOffset + number]);
		monster->monsTileOnTopOf = (unsigned char)((*monsters)[kMonsTileOnOffset + number]);
		monster->monsPosition.h = (unsigned char)((*monsters)[kMonsXPosOffset + number]);
		monster->monsPosition.v = (unsigned char)((*monsters)[kMonsYPosOffset + number]);
		tmp = (*monsters)[kMonsInclinOffset + number];
		monster->monsTLKSID = tmp & 0x0F;
		monster->monsInclination = (tmp & 0xF0) >> 4;
	}
}

void SetMonster(short monsID, MonsterRec *monster)
{
	Handle monsters = gScenario.monsters[monsID].mons;
	short number;
	
	if (!monster) return;

	number = monster->monsNumber;
	if ((number < 0 ) || (number >= kMaxMonsters)) return;
	
	(*monsters)[kMonsTileTypeOffset + number] = monster->monsTileType;
	(*monsters)[kMonsTileOnOffset + number] = monster->monsTileOnTopOf;
	(*monsters)[kMonsXPosOffset + number] = monster->monsPosition.h;
	(*monsters)[kMonsYPosOffset + number] = monster->monsPosition.v;
	(*monsters)[kMonsInclinOffset + number] = ((monster->monsInclination << 4) & 0xF0) + 
											   (monster->monsTLKSID & 0x0F);
}
