/*
 * Scen LDEF.c
 *
 * LDEF for the Scenario Window.
 *
 * This will start off simply at first, but I hope it can blossom into a complex
 * LDEF similar to the Metrowerks Project Window LDEF (or whatever that is).
 *
 * This is, essentially, only for drawing the LDEF.
 */

#include "Scen LDEF.h"

Ptr HiliteMode = (Ptr)0x938; 	// Am I evil? Yes I am.

/* MyList
 * The Norstad stub-trick call-back routine. The proc pointer must be stored
 * in the LDEF's refCon!!
 */
void ScenList(short lMessage, Boolean lSelect, Rect *lRect, Cell lCell,
					short lDataOffset, short lDataLen, ListHandle lHandle)
{
	Ptr cellData;
	ListPtr theListPtr;
	SignedByte hStateList, hStateCells;
	FontInfo fontInfo;
	short	curFont;
	Str255	s;
	RgnHandle saveRgn;
	Rect	clipRect;

	// Lock down the handles
	hStateList = HGetState((Handle) lHandle);
	HLock((Handle) lHandle);
	theListPtr = *lHandle;
	hStateCells = HGetState((Handle) theListPtr->cells);
	HLock((Handle) theListPtr->cells);
	cellData = *(theListPtr->cells);
	
	GetFontInfo(&fontInfo);
	curFont = (*lHandle)->port->txFont;
	
	switch(lMessage) {
	case lDrawMsg:
		TextFont(1);	// Geneva
		EraseRect(lRect);
		saveRgn = NewRgn();
		GetClip(saveRgn);
		
	// Do Drawing
		
		SetClip(saveRgn);

		if (lSelect) {
			BitClr(HiliteMode, pHiliteBit);	/* THIS is how you hilite with the default color. */
	  		InvertRect(lRect);	
		} 

		DisposeRgn(saveRgn);
		break;
	case lHiliteMsg:
		BitClr(HiliteMode, pHiliteBit);
	  	InvertRect(lRect);	
		break;
	default:
		;
	}
	
	// Restore everything, please
	
	TextFont(curFont);
	HSetState((Handle) theListPtr->cells,hStateCells);
	HSetState((Handle) lHandle, hStateList);
}
